Toolang API
Reference for the local Toolang agent HTTP API.
Endpoints
Activity
Live execution activity.
GET /api/v0/top/snapshot
Snapshot
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| recent | query | no | integer | 300 | value >= 1; value <= 900 |
| before_time | query | no | string | null | ||
| after_id | query | no | string | null | ||
| completed_at | query | no | integer | null | integer: value >= 0 |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ActivitySnapshot |
| 422 | Validation Error | application/json | HTTPValidationError |
Agent
Agent profile, health, and operational update endpoints.
GET /api/v0/agics
List Agent Agics
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/flows
List Agent Flows
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/models
List Agent Models
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/profile
Get Profile
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/prompt-completions
List Prompt Completions
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| runnable | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/stream
Stream Agent Events
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| after | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/tools
List Agent Tools
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/workspaces
List Agent Workspaces
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| workdir | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | WorkspaceInspection |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /healthz
Health Check
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object<string, boolean> |
PUT /api/v0/runtime/leases/{client_id}
Retain Server
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| client_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RuntimeLaunchRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | RuntimeLifecyclePayload |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runtime/promote
Keep Server Running
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RuntimeLaunchRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | RuntimeLifecyclePayload |
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/runtime/leases/{client_id}
Release Server
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| client_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RuntimeLaunchRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object<string, boolean> |
| 422 | Validation Error | application/json | HTTPValidationError |
Caps
Capability inspection and mutation endpoints.
GET /api/v0/caps
Get Caps Summary
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/prompts
List Prompts
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<CapInfo> |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/prompts/templates
List Prompt Templates
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<object> |
GET /api/v0/prompts/templates/default
Get Prompt Template
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/prompts/{name}
Get Prompt
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/psyches
List Psyches
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<CapInfo> |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/psyches/templates
List Psyche Templates
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<object> |
GET /api/v0/psyches/templates/default
Get Psyche Template
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/psyches/{name}
Get Psyche
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/services
List Services
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<CapInfo> |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/services/templates
List Service Templates
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<object> |
GET /api/v0/services/templates/default
Get Service Template
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/services/{name}
Get Service
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/skills
List Skills
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| query | query | no | array<string> | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<CapInfo> |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/skills/templates
List Skill Templates
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<object> |
GET /api/v0/skills/templates/default
Get Skill Template
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
GET /api/v0/skills/{name}
Get Skill
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/prompts/{name}/authored
Upsert Authored Prompt
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | PutCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/prompts/{name}/configured
Configure Prompt
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ConfiguredCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/psyches/{name}/authored
Upsert Authored Psyche
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | PutCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/psyches/{name}/configured
Configure Psyche
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ConfiguredCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/services/{name}/authored
Upsert Authored Service
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | PutCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/services/{name}/configured
Configure Service
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ConfiguredCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/skills/{name}/authored
Upsert Authored Skill
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | PutCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
PUT /api/v0/skills/{name}/configured
Configure Skill
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ConfiguredCapRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | CapDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/prompts/{name}/authored
Delete Authored Prompt
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/prompts/{name}/configured
Remove Configured Prompt
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/psyches/{name}/authored
Delete Authored Psyche
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/psyches/{name}/configured
Remove Configured Psyche
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/services/{name}/authored
Delete Authored Service
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/services/{name}/configured
Remove Configured Service
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/skills/{name}/authored
Delete Authored Skill
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/skills/{name}/configured
Remove Configured Skill
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| name | path | yes | string | ||
| scope | query | no | home | root | "home" |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
Chores
Chore definition and execution endpoints.
GET /api/v0/chores
List Chores
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<ChoreInfo> |
GET /api/v0/chores/{chore_id}
Get Chore
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| chore_id | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ChoreDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chores
Create Chore
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ChoreCreateRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 201 | Successful Response | application/json | ChoreDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chores/{chore_id}/cancel
Cancel Chore
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| chore_id | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chores/{chore_id}/run
Run Chore
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| chore_id | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 202 | Successful Response | application/json | any |
| 422 | Validation Error | application/json | HTTPValidationError |
DELETE /api/v0/chores/{chore_id}
Delete Chore Definition
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| chore_id | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 204 | Successful Response | ||
| 422 | Validation Error | application/json | HTTPValidationError |
PATCH /api/v0/chores/{chore_id}
Update Chore
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| chore_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ChorePatchRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ChoreDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
Runs
Run execution and inspection endpoints.
GET /api/v0/runs
List Runs
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| limit | query | no | integer | 50 | |
| thread_id | query | no | string | null | ||
| status | query | no | pending | running | succeeded | failed | canceled | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<RunInfo> |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/runs/defaults
Get Run Defaults
Return concrete defaults and workdir for a client-owned run session.
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| thread_id | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/runs/live
Get Live Execution Trees
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| root_run_id | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | LiveSnapshot |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/runs/{run_id}
Get Run
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | RunDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/runs/{run_id}/stream
Stream Run Events
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string | ||
| after | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chat/runs/authored/stream
Execute Authored Run Stream
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| after | query | no | string | null |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | AuthoredRunRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chat/runs/stream
Execute Run Stream
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| after | query | no | string | null |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RunCreateRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chat/runs/{run_id}/rerun
Rerun Run
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | no | RunRerunRequest | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 202 | Successful Response | application/json | RunCommandResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chat/runs/{run_id}/rerun/stream
Rerun Authored Run Stream
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string | ||
| after | query | no | string | null |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | AuthoredRerunRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/chat/runs/{run_id}/steer
Steer Run
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RunSteerRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 202 | Successful Response | application/json | RunCommandResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/authored/stream
Execute Authored Run Stream
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| after | query | no | string | null |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | AuthoredRunRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/input-references
Discover Client File Inputs
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | InputReferencesRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | InputReferencesResponse |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/stream
Execute Run Stream
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| after | query | no | string | null |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RunCreateRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/threads
Create Execution Thread
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ThreadCreateRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 201 | Successful Response | application/json | ThreadResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/workdir/resolve
Resolve Run Workdir
Resolve a proposed location without accepting or mutating a Run.
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | WorkdirResolveRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | object<string, string> |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/{run_id}/cancel
Cancel Run
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | no | RunCancelRequest | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | RunCommandResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/{run_id}/rerun
Rerun Run
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | no | RunRerunRequest | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 202 | Successful Response | application/json | RunCommandResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/{run_id}/rerun/stream
Rerun Authored Run Stream
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string | ||
| after | query | no | string | null |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | AuthoredRerunRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/runs/{run_id}/steer
Steer Run
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| run_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | RunSteerRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 202 | Successful Response | application/json | RunCommandResult |
| 422 | Validation Error | application/json | HTTPValidationError |
Threads
Thread lifecycle and inspection endpoints.
GET /api/v0/threads
List Threads
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| limit | query | no | integer | 50 | |
| kind | query | no | ThreadKind | null | ||
| status | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | array<ThreadInfo> |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/threads/{thread_id}
Get Thread
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| thread_id | path | yes | string | ||
| limit | query | no | integer | 50 |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ThreadDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/threads/{thread_id}/result
Get Latest Thread Result
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| thread_id | path | yes | string |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | RunDetail |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/threads/{thread_id}/stream
Stream Thread Events
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| thread_id | path | yes | string | ||
| after | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | text/event-stream | any |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/threads
Create Thread
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ThreadCreateRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 201 | Successful Response | application/json | ThreadResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/threads/{thread_id}/fork
Fork Thread
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| thread_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ThreadForkRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ThreadResult |
| 422 | Validation Error | application/json | HTTPValidationError |
POST /api/v0/threads/{thread_id}/rewind
Rewind Thread
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| thread_id | path | yes | string |
Request body:
| Content Type | Required | Schema |
|---|---|---|
| application/json | yes | ThreadRewindRequest |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ThreadResult |
| 422 | Validation Error | application/json | HTTPValidationError |
Stats
Execution usage by time, scope, and model.
GET /api/v0/stats/daily
Daily
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| start_date | query | yes | string (date) | ||
| end_date | query | yes | string (date) | ||
| timezone | query | yes | string | ||
| model_ref | query | no | string | null | string: length >= 1 | |
| thread_id | query | no | string | null | ||
| root_run_id | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | StatsResponse_list_DailyRow__ |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/stats/models
Models
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| window | query | no | all | 1y | 1mo | 1w | 1d | 4h | 1h | 30m | "1mo" | |
| thread_id | query | no | string | null | ||
| root_run_id | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | ModelsResponse |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/stats/recent
Recent
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| period | query | no | integer | 3600 | value >= 1; value <= 28800 |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | RecentUsage |
| 422 | Validation Error | application/json | HTTPValidationError |
GET /api/v0/stats/summary
Summary
Parameters:
| Name | In | Required | Type | Default | Description |
|---|---|---|---|---|---|
| model_ref | query | no | string | null | string: length >= 1 | |
| thread_id | query | no | string | null | ||
| root_run_id | query | no | string | null |
Responses:
| Status | Description | Content Type | Schema |
|---|---|---|---|
| 200 | Successful Response | application/json | StatsResponse_list_WindowRow__ |
| 422 | Validation Error | application/json | HTTPValidationError |
Schemas
Schema: ActivitySnapshot
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
completed | yes | CompletedRoots | ||
idle | no | boolean | false | |
live | yes | LiveSnapshot | null | ||
live_error | no | string | null | ||
page_error | no | string | null | ||
retired | no | array<RunNode> | [] |
Schema: AgentCapResource
Stable identity of one State capability available to an agent.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | yes | string | ||
name | yes | string | ||
ref | yes | string |
Schema: AgentCeiling
Stable queries that can only narrow agent resources.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
models | no | array<string> | null | ||
prompts | no | array<string> | null | ||
psyches | no | array<string> | null | ||
services | no | array<string> | null | ||
skills | no | array<string> | null | ||
tools | no | array<string> | null |
Schema: AgentResources
Stable ordered resources available at one execution point.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
caps | no | array<AgentCapResource> | [] | |
models | no | array<string> | [] | |
tools | no | array<AgentToolResource> | [] |
Schema: AgentToolResource
Stable identity of one model-facing tool available to an agent.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
model_name | yes | string | ||
name | yes | string | ||
plugin | yes | string | ||
toolset | yes | string |
Schema: Array_Value_
One immutable typed Toolang array.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
type | yes | string | ||
value | yes | array<Value> |
Schema: AskStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
name | no | string | null | ||
request | yes | string | ||
span | yes | Span |
Schema: AudioInputPart
One audio input part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | no | string | null | ||
data_url | no | string | null | ||
filename | no | string | null | ||
format | no | mp3 | wav | null | ||
media_type | no | string | null | ||
type | yes | audio |
Schema: AudioPart-Input
One canonical audio input part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | yes | string | ||
filename | no | string | null | ||
format | yes | mp3 | wav | ||
media_type | no | string | null | ||
transcript | no | string | null | ||
type | no | audio | "audio" |
Schema: AudioPart-Output
One canonical audio input part.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | yes | string | ||
filename | no | string | null | ||
format | yes | mp3 | wav | ||
media_type | no | string | null | ||
transcript | no | string | null | ||
type | no | audio | "audio" |
Schema: AuthoredRerunRequest
One unresolved rerun request for server-owned resolution.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
commands | no | array<RunOverridePayload> | ||
model | no | ModelRequest | null | ||
model_override | no | ModelOverride | null | ||
request_id | yes | string |
Schema: AuthoredRunRequest
One materialized authored run request.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
attachments | no | object<string, TextPart-Input | ReasoningPart-Input | ImagePart-Input | AudioPart-Input | DocumentPart-Input | ToolCallPart-Input | ToolResultPart-Input> | null | ||
client_id | no | string | null | string: length >= 1 | |
driver | no | chat | chore | talk | null | ||
model | yes | ModelRequest | null | ||
policy | yes | RunPolicy | ||
request_id | yes | string | ||
runnable | yes | RunnableRequest_str_ | ||
source_revision | no | string | null | ||
thread_id | yes | string | ||
workdir | no | string | null | ||
workdir_base | no | string | null |
Schema: AwaitStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
handle | yes | string | ||
span | yes | Span |
Schema: CallCounters
Actual model/tool invocation entries within one Run subtree.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
model_calls | no | integer | 0 | |
tool_calls | no | integer | 0 |
Schema: CancelControlPayload
Optional run cancellation reason values.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
input | no | object<string, Value | string> |
Schema: CapDetail
Complete representation of one effective capability.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cap | yes | string | ||
content | no | string | null | ||
definition_file | yes | string | ||
description | yes | string | null | ||
editable | yes | boolean | ||
files | no | array<string> | null | ||
form | yes | authored | inline | configured | referenced | ||
kind | yes | psyche | skill | service | prompt | ||
line | no | integer | null | ||
name | yes | string | ||
origin | yes | local | remote | ||
scope | yes | root | home | here | ||
source | yes | string | ||
summary | no | string | null |
Schema: CapInfo
Summary of one effective capability.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cap | yes | string | ||
definition_file | yes | string | ||
description | yes | string | null | ||
editable | yes | boolean | ||
form | yes | authored | inline | configured | referenced | ||
kind | yes | psyche | skill | service | prompt | ||
line | no | integer | null | ||
name | yes | string | ||
origin | yes | local | remote | ||
scope | yes | root | home | here | ||
source | yes | string | ||
summary | no | string | null |
Schema: ChdirControlPayload
One durable Run-local working location transition.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cause | no | chdir | "chdir" | |
cwd | yes | string | ||
state | no | string | null |
Schema: ChoreCreateRequest
Request one authored chore creation.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
body | no | string | "" | |
name | yes | string | ||
schedule | no | string | null | ||
title | no | string | null |
Schema: ChoreDetail
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
body | yes | string | ||
id | yes | string | null | ||
line | yes | integer | null | ||
name | yes | string | ||
path | yes | string | ||
ref | yes | string | ||
runtime | yes | ChoreRuntimeInfo | ||
schedule | yes | string | null | ||
source_error | yes | string | null | ||
title | yes | string |
Schema: ChoreInfo
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
id | yes | string | null | ||
line | yes | integer | null | ||
name | yes | string | ||
path | yes | string | ||
ref | yes | string | ||
runtime | yes | ChoreRuntimeInfo | ||
schedule | yes | string | null | ||
source_error | yes | string | null | ||
title | yes | string |
Schema: ChorePatchRequest
Request one authored chore update.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
body | no | string | null | ||
schedule | no | string | null | ||
title | no | string | null |
Schema: ChoreRuntimeInfo
Checkpoint state; synced indicates whether it describes the current definition.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
active_run_id | yes | string | null | ||
last_run | yes | LastRunInfo | null | ||
next_scheduled_at | yes | string | null | ||
pending_at | yes | string | null | ||
scheduler_error | yes | string | null | ||
status | yes | pending | running | done | failed | canceled | null | ||
synced | yes | boolean | ||
thread_id | yes | string | null | ||
updated_at | yes | string | null |
Schema: CollectionStepReport
Collection cardinality learned while executing one Flow Step.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
output_items | no | integer | null | ||
total_items | yes | integer |
Schema: CompactControlPayload
One published compaction made available for adoption.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
horizon | yes | string |
Schema: CompletedRoots
One bounded page, with counts over the entire completion interval.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
counts | yes | CompletionCounts | ||
end | yes | string | ||
observed_at | yes | string | ||
roots | yes | array<RunNode> | ||
start | yes | string |
Schema: CompletionCounts
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
canceled | no | integer | 0 | |
failed | no | integer | 0 | |
succeeded | no | integer | 0 | |
total | yes | integer |
Schema: ConfiguredCapRequest
One configured cap ref mutation request.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
ref | yes | string | ||
scope | no | home | root | "home" |
Schema: ControlInfo
One accepted execution control.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | ||
created_at | yes | string | ||
error | yes | string | null | ||
finished_at | yes | string | null | ||
index | yes | integer | ||
kind | yes | run | chdir | recall | compact | exec | steer | cancel | create | fork | rewind | ||
payload | yes | RunControlPayload | ChdirControlPayload | CompactControlPayload | ExecControlPayload | SteerControlPayload | CancelControlPayload | RecallControlPayload | CreateControlPayload | ForkControlPayload | RewindControlPayload | ||
request_id | yes | string | null | ||
run_id | yes | string | ||
status | yes | pending | applied | wontapply | revoked | ||
timing | yes | immediate | next_step | next_call | ||
triggered_by | no | string | null |
Schema: ConversationScope
A source conversation bound to one invocation, never to a prefix.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
backend | yes | string | ||
conversation | yes | string |
Schema: ConvoRulesRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
backend | yes | string | ||
conversation | yes | string | ||
kind | no | convo-rules | "convo-rules" |
Schema: DailyRow
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cached | yes | integer | null | ||
date | yes | string (date) | ||
end | yes | string | ||
in | yes | integer | null | ||
model_calls | yes | integer | ||
out | yes | integer | null | ||
partial | yes | boolean | ||
root_runs | yes | integer | null | ||
spend | yes | number | null | ||
spend_approximate | yes | boolean | ||
start | yes | string | ||
tool_calls | yes | integer |
Schema: DocumentInputPart
One document input part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | no | string | null | ||
file_id | no | string | null | ||
filename | no | string | null | ||
media_type | no | string | null | ||
type | yes | document | ||
url | no | string | null |
Schema: DocumentPart-Input
One canonical document part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | no | string | null | ||
file_id | no | string | null | ||
filename | no | string | null | ||
media_type | no | string | null | ||
type | no | document | "document" | |
url | no | string | null |
Schema: DocumentPart-Output
One canonical document part.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | no | string | null | ||
file_id | no | string | null | ||
filename | no | string | null | ||
media_type | no | string | null | ||
type | no | document | "document" | |
url | no | string | null |
Schema: DropStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
count | no | integer | null | ||
doc | no | string | null | ||
lanes | no | integer | null | ||
position | no | first | last | null | ||
runnable | no | string | null | ||
span | yes | Span |
Schema: ExecControlPayload
One durable same-Run runnable replacement.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
input | yes | object<string, Value | string> | ||
runnable | yes | string | ||
runnable_kind | no | string | "" | |
state | yes | string |
Schema: ExecStepReport
Committed native handoff, independent of successor Step delivery.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
control | yes | string |
Schema: ExecStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | null | ||
doc | no | string | null | ||
runnable | yes | string | ||
span | yes | Span |
Schema: ForkControlPayload
Fork one thread at a visible run.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
fork_at | yes | string | ||
fork_from | yes | string | ||
fork_head | yes | string |
Schema: GenerateStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
count | yes | integer | ||
doc | no | string | null | ||
lanes | no | integer | null | ||
runnable | yes | string | ||
span | yes | Span |
Schema: ImageInputPart
One image input part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
detail | no | low | high | auto | original | "auto" | |
file_id | no | string | null | ||
filename | no | string | null | ||
image_url | no | string | null | ||
media_type | no | string | null | ||
type | yes | image |
Schema: ImagePart-Input
One canonical image input part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
detail | no | low | high | auto | original | "auto" | |
file_id | no | string | null | ||
filename | no | string | null | ||
image_url | no | string | null | ||
media_type | no | string | null | ||
type | no | image | "image" |
Schema: ImagePart-Output
One canonical image input part.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
detail | no | low | high | auto | original | "auto" | |
file_id | no | string | null | ||
filename | no | string | null | ||
image_url | no | string | null | ||
media_type | no | string | null | ||
type | no | image | "image" |
Schema: InputMessagePayload
One user-authored input message.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
parts | yes | array<TextInputPart | ImageInputPart | AudioInputPart | DocumentInputPart> | ||
role | no | user | "user" |
Schema: InputReferencesRequest
Discover includes in source Content without reading server files.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
driver | no | chat | chore | talk | null | ||
input | yes | object<string, string> | ||
runnable | no | string | null |
Schema: InputReferencesResponse
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
references | yes | array<string> | ||
state | yes | string |
Schema: IterationOccurrence
One loop iteration and the phase executing within it.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
count | no | integer | null | ||
index | yes | integer | ||
phase | yes | body | until |
Schema: KeepStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
count | no | integer | null | ||
doc | no | string | null | ||
lanes | no | integer | null | ||
position | no | first | last | null | ||
runnable | no | string | null | ||
span | yes | Span |
Schema: LastRunInfo
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
error | no | string | null | ||
finished_at | yes | string | null | ||
id | yes | string | ||
started_at | yes | string | null | ||
status | yes | string |
Schema: LaunchContext
Captured context and result contract for admitted background work.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
iterations | yes | object | ||
result | yes | OutputContract | null | ||
settings | yes | RunnableSettings | ||
workspaces | yes | object<string, string> |
Schema: LetStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
span | yes | Span | ||
value | yes | string |
Schema: LiveSnapshot
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
epoch | yes | string | ||
observed_at | yes | string | ||
trees | yes | array<LiveTreeSnapshot> |
Schema: LiveTreeSnapshot
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
nodes | yes | array<RunNode | StepNode> | ||
root_run_id | yes | string | ||
thread_id | yes | string |
Schema: LoopStepReport
Iteration count and terminal cause learned when a loop Step ends.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
iterations | yes | integer | ||
termination | yes | exhausted | satisfied | exec | failed | canceled | ||
total | no | integer | null |
Schema: MapStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
lanes | no | integer | null | ||
runnable | yes | string | ||
span | yes | Span |
Schema: Message
Stable canonical message payload.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
parts | no | array<TextPart-Output | ReasoningPart-Output | ImagePart-Output | AudioPart-Output | DocumentPart-Output | ToolCallPart-Output | ToolResultPart-Output> | ||
role | yes | user | assistant | tool |
Schema: MessageRecall
The resource revision actually presented by a tagged message.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
ref | yes | string | ||
revision | yes | string |
Schema: Metrics
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cached_tokens | no | integer | null | 0 | |
input_tokens | no | integer | null | 0 | |
model_calls | no | integer | 0 | |
output_tokens | no | integer | null | 0 | |
root_runs | no | integer | 0 | |
spend_approximate | no | boolean | false | |
spend_micros | no | integer | null | 0 | |
tool_calls | no | integer | 0 |
Schema: ModelCall
One normalized model call.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cont | no | object | null | ||
instructions | yes | string | ||
max_output_tokens | no | integer | null | ||
messages | yes | array<Message> | ||
output_schema | no | object | null | ||
reasoning | no | Reasoning | null | ||
tools | no | array<ToolDefinition> |
Schema: ModelCost
Selected model charge and the pricing/calculation evidence behind it.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
amount | no | number | null | ||
complete | no | boolean | false | |
currency | no | string | null | ||
lines | no | array<ModelCostLine> | [] | |
meters | no | array<ModelUsageMeter> | [] | |
pricing | no | ModelPricing | null | ||
source | no | reported | estimated | zero | unknown | "unknown" |
Schema: ModelCostLine
One applied quantity and rate contributing to a model cost.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
amount | yes | number | ||
condition | no | object | null | ||
meter | yes | string | ||
per | yes | number | ||
quantity | yes | number | ||
rate | yes | number | ||
unit | yes | string |
Schema: ModelOverride
Sparse model identity and typed parameter changes from one input source.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
effort | no | string | integer | auto | null | ||
identity | no | string | null | ||
max_output | no | integer | auto | null |
Schema: ModelPricing
Applied pricing plan and conditions captured for one completed call.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
match | no | object | ||
plan | no | string | "standard" |
Schema: ModelRequest
One exact model ref and the controls this run asks for.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
max_output | no | integer | null | ||
reasoning | no | Reasoning | null | ||
ref | yes | string |
Schema: ModelRow
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cached | yes | integer | null | ||
in | yes | integer | null | ||
model_calls | yes | integer | ||
model_ref | yes | string | ||
out | yes | integer | null | ||
root_runs | yes | integer | null | ||
spend | yes | number | null | ||
spend_approximate | yes | boolean | ||
tool_calls | yes | integer |
Schema: ModelsResponse
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
data | yes | array<ModelRow> | null | ||
end | yes | string | null | ||
scope | yes | Scope | ||
snapshot | yes | Snapshot | ||
start | yes | string | null | ||
window | yes | all | 1y | 1mo | 1w | 1d | 4h | 1h | 30m |
Schema: ModelStepReport
Token usage, model cost and continuation learned by one model Step.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cont | no | object | null | ||
cost | no | ModelCost | null | ||
invoked | no | boolean | false | |
usage | no | TokenUsage | null |
Schema: ModelStepSpec
Resolved model identity and normalized call known at Step begin.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call | yes | ModelCall | ||
model | yes | string | ||
setup | yes | string | ||
state | no | string | null |
Schema: ModelUsageMeter
One auditable quantity within model-call accounting.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
name | yes | string | ||
quantity | yes | number | ||
unit | no | string | "token" |
Schema: Occurrence
Runtime position of one Run or Step within structural execution.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
item | no | OccurrencePosition | null | ||
iteration | no | IterationOccurrence | null | ||
lane | no | OccurrencePosition | null |
Schema: OccurrencePosition
One zero-based position within a known total.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
count | yes | integer | ||
index | yes | integer |
Schema: OutputContract
One output type and its referenced struct definitions at a call boundary.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
definitions | yes | object<string, array<tuple<string, string, boolean>>> | ||
type_name | yes | string |
Schema: PromptInvocation
One resolved authored prompt invocation and its immutable definition.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
arguments | yes | array<tuple<string, string>> | ||
cap_ref | yes | string | ||
content_hash | yes | string | ||
name | yes | string | ||
parent | yes | integer | null |
Schema: PromptSetting
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
module | yes | string | ||
name | no | string | "default" |
Schema: PsycheRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | psyche | "psyche" | |
ref | yes | string |
Schema: PutCapRequest
One authored cap write request.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
content | no | string | null | ||
scope | no | home | root | "home" |
Schema: Reasoning
One reasoning control requested for a model selection or call.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
budget_tokens | no | integer | null | ||
effort | no | string | null |
Schema: ReasoningPart-Input
Provider-returned reasoning text and its opaque native state.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
provider | no | string | null | ||
provider_metadata | no | object | ||
signature | no | string | null | ||
text | yes | string | ||
type | no | reasoning | "reasoning" |
Schema: ReasoningPart-Output
Provider-returned reasoning text and its opaque native state.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
provider | no | string | null | ||
provider_metadata | no | object | ||
signature | no | string | null | ||
text | yes | string | ||
type | no | reasoning | "reasoning" |
Schema: RecallControlPayload
One immutable resource revision recalled by the runtime.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
content | yes | string | ||
revision | yes | string | ||
target | yes | ConvoRulesRecallTarget | RulesRecallTarget | SkillRecallTarget | ServiceRecallTarget | PsycheRecallTarget | SkillTriggerRecallTarget | ServiceTriggerRecallTarget | WorkspaceRecallTarget |
Schema: RecentUsage
Exact source-only usage in a bounded half-open interval.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
end | yes | string | ||
metrics | yes | Metrics | ||
observed_at | yes | string | ||
start | yes | string |
Schema: ReduceStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
initial | no | string | null | ||
runnable | yes | string | ||
span | yes | Span |
Schema: RepeatStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | null | ||
count | no | integer | null | ||
doc | no | string | null | ||
runnable | no | string | null | ||
span | yes | Span | ||
stmts | no | array<RunStmt | AwaitStmt | SpawnStmt | ExecStmt | SeekStmt | AskStmt | GenerateStmt | ReduceStmt | MapStmt | KeepStmt | DropStmt | SortStmt | RepeatStmt | LetStmt> | [] | |
until_index | no | integer | null | ||
window | no | integer | 3 |
Schema: RewindControlPayload
Rewind one thread with an optimistic head check.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
rewind_from | yes | string | ||
rewind_if | yes | string | ||
rewind_through | yes | string |
Schema: RulesRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | rules | "rules" | |
path | yes | string | ||
workspace | yes | string |
Schema: RunCancelRequest
Request run cancellation.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
expected_control | no | string | null | ||
mode | no | immediate | next_step | next_call | "immediate" | |
reason | no | string | null | ||
request_id | no | string | null |
Schema: RunCommand
One low-level command retained by execution and restart protocols.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
field | yes | string | ||
group | yes | allow | default | limit | ||
value | yes | array<string> | string | integer | number | null |
Schema: RunCommandResult
One accepted HTTP run control.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
command | yes | ControlInfo | ||
run | yes | RunDetail |
Schema: RunControlPayload
Resolved preparation snapshot for one new run.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
authored_commands | no | array<RunCommand> | [] | |
authored_input | no | object<string, string> | null | ||
authored_session_commands | no | array<RunCommand> | [] | |
conversation | no | ConversationScope | null | ||
cwd | no | string | "" | |
horizon | no | string | null | ||
input | yes | object<string, Value | string> | ||
launch_context | no | LaunchContext | null | ||
limits | yes | RunLimits-Output | ||
model_request | no | ModelRequest | null | ||
prompt_invocations | no | array<PromptInvocation> | [] | |
resources | yes | AgentResources | ||
runnable | yes | string | ||
runnable_kind | no | string | "" | |
runtime_sources | no | object<string, string> | ||
sandbox | no | string | null | ||
spawn_thread | no | string | null | ||
state | yes | string | null |
Schema: RunControlRefData
One caller-facing run-control reference.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
index | yes | integer | ||
run | yes | string |
Schema: RunCreateRequest
One non-interactive agic or flow execution request.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
model | yes | ModelRequest | null | ||
policy | yes | RunPolicy | ||
request_id | yes | string | length >= 1 | |
runnable | yes | RunnableRequest_object_ | ||
thread_id | yes | string | length >= 1 |
Schema: RunDetail
One complete run detail schema.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_kind | yes | string | ||
control | yes | RunControlRefData | ||
controls | yes | array<ControlInfo> | ||
created_at | yes | string | ||
error | yes | object | null | ||
finished_at | yes | string | null | ||
id | yes | string | ||
input_text | yes | string | ||
occurrence | yes | Occurrence | null | ||
output | yes | object | null | ||
parent | yes | string | null | ||
root_run_id | yes | string | ||
runnable_kind | yes | string | ||
runnable_name | yes | string | null | ||
started_at | yes | string | ||
state | yes | RunControlRefData | ||
status | yes | pending | running | succeeded | failed | canceled | ||
steps | no | array<StepData> | ||
summary | yes | string | ||
thread_id | yes | string | ||
updated_at | yes | string |
Schema: RunInfo
One caller-facing run summary and identity schema.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_kind | yes | string | ||
created_at | yes | string | ||
error | yes | object | null | ||
finished_at | yes | string | null | ||
id | yes | string | ||
input_text | yes | string | ||
occurrence | yes | Occurrence | null | ||
parent | yes | string | null | ||
root_run_id | yes | string | ||
runnable_kind | yes | string | ||
runnable_name | yes | string | null | ||
started_at | yes | string | ||
state | yes | RunControlRefData | ||
status | yes | pending | running | succeeded | failed | canceled | ||
summary | yes | string | ||
thread_id | yes | string | ||
updated_at | yes | string |
Schema: RunLimits-Input
Limits applied to one root run tree.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
agic_model_calls | no | integer | null | 200 | |
agic_tool_calls | no | integer | null | ||
cost | no | number | null | ||
time | no | integer | null | ||
tokens | no | integer | null |
Schema: RunLimits-Output
Limits applied to one root run tree.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
agic_model_calls | no | integer | null | 200 | |
agic_tool_calls | no | integer | null | ||
cost | no | string | null | ||
time | no | integer | null | ||
tokens | no | integer | null |
Schema: RunLimitsPayload
One partial run-limit override.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
agic_model_calls | no | integer | null | integer: value >= 0.0 | |
agic_tool_calls | no | integer | null | integer: value >= 0.0 | |
cost | no | number | null | ||
time | no | integer | null | integer: value >= 0.0 | |
tokens | no | integer | null | integer: value >= 0.0 |
Schema: RunnableRequest_object_
One optional entry selection and its complete input.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
input | no | object | ||
ref | yes | string | null |
Schema: RunnableRequest_str_
One optional entry selection and its complete input.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
input | no | object<string, string> | ||
ref | yes | string | null |
Schema: RunnableSettings
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
context | no | PromptSetting | null | ||
handoffs | no | array<string> | [] | |
hands | no | array<string> | [] | |
instruct | no | PromptSetting | null | ||
lanes | no | integer | 4 | |
module | no | string | "agent" | |
recall | no | array<string> | ["far", "near"] |
Schema: RunNode
Small resident Run state and cumulative subtree consumption.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
calls | no | CallCounters | ||
cost | no | number | null | ||
cost_approximate | no | boolean | false | |
created_at | yes | string | ||
finished_at | no | string | null | ||
id | yes | string | ||
occurrence | no | Occurrence | null | ||
parent | yes | string | null | ||
runnable | yes | string | ||
runnable_kind | no | string | "" | |
started_at | no | string | null | ||
status | yes | pending | running | succeeded | failed | canceled | ||
thread_id | no | string | null | ||
type | no | run | "run" | |
usage | no | TokenUsage | null |
Schema: RunOverridePayload
One retained low-level restart command on the stable HTTP wire.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
field | yes | string | ||
group | yes | allow | default | limit | ||
value | yes | array<string> | string | integer | null |
Schema: RunPolicy
Materialized caller policy for one root run.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
allow | no | array<AgentCeiling> | [] | |
limits | no | RunLimits-Input |
Schema: RunRerunRequest
Request a new run from one source invocation.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
limits | no | RunLimitsPayload | null | ||
model | no | ModelRequest | null | ||
request_id | no | string | null | string: length >= 1 |
Schema: RunSteerRequest
Request one steering message for a running run.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
expected_control | no | string | null | ||
message | yes | InputMessagePayload | ||
mode | no | immediate | next_step | next_call | "next_step" | |
request_id | no | string | null |
Schema: RunStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
asynchronous | no | boolean | false | |
binding | no | string | null | "_" | |
doc | no | string | null | ||
runnable | yes | string | ||
span | yes | Span |
Schema: RuntimeLaunchRequest
Target one server generation for retention or promotion.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
launch_id | yes | string | length >= 1 |
Schema: RuntimeLifecyclePayload
Live server retention policy, independent of driver selection.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
api_version | no | integer | 0 | value >= 0.0; value <= 0.0 |
launch_id | yes | string | ||
lifetime | yes | persistent | foreground | automatic |
Schema: Scope
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
id | no | string | "" | |
kind | no | agent | thread | root_run | "agent" |
Schema: SeekStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
name | yes | string | ||
runnable | yes | string | ||
span | yes | Span |
Schema: ServiceRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | service | "service" | |
ref | yes | string |
Schema: ServiceTriggerRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | service-trigger | "service-trigger" | |
ref | yes | string |
Schema: SkillRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | skill | "skill" | |
ref | yes | string |
Schema: SkillTriggerRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | skill-trigger | "skill-trigger" | |
ref | yes | string |
Schema: Snapshot
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
computed_at | yes | string | null | ||
initializing | yes | boolean | ||
queried_at | yes | string | ||
refresh_error | yes | string | null | ||
refreshing | yes | boolean | ||
stale | yes | boolean |
Schema: SortStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | "_" | |
doc | no | string | null | ||
lanes | no | integer | null | ||
order | yes | ascending | descending | ||
runnable | yes | string | ||
span | yes | Span |
Schema: Span
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
line | yes | integer |
Schema: SpawnStmt
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
binding | no | string | null | ||
doc | no | string | null | ||
runnable | yes | string | ||
span | yes | Span |
Schema: StatsResponse_list_DailyRow__
StatsResponse[list[DailyRow]]
Schema: StatsResponse_list_WindowRow__
StatsResponse[list[WindowRow]]
Schema: SteerControlPayload
Values injected at one agic model boundary.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
input | yes | object<string, Value | string> |
Schema: StepData
One caller-facing execution step.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
aborted_by | no | string | null | ||
created_at | no | string | "" | |
error | no | object | null | ||
finished_at | no | string | null | ||
input | yes | array<string> | ||
kind | yes | exec | run | spawn | agent | human | model | tool | par | loop | value | ||
occurrence | no | Occurrence | null | ||
output | yes | object | null | ||
path | yes | string | ||
preceded_by | no | array<string> | [] | |
report | no | ExecStepReport | ModelStepReport | ToolStepReport | CollectionStepReport | LoopStepReport | null | ||
spec | yes | any | ||
started_at | no | string | "" | |
state | yes | RunControlRefData | ||
status | no | pending | running | succeeded | failed | canceled | "running" |
Schema: StepNode
Current Step identity and direct invocation facts, without call bodies.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
asynchronous | no | boolean | false | |
cost | no | number | null | ||
cost_approximate | no | boolean | false | |
created_at | yes | string | ||
finished_at | no | string | null | ||
id | yes | string | ||
invoked | no | boolean | false | |
kind | yes | exec | run | spawn | agent | human | model | tool | par | loop | value | ||
name | no | string | "" | |
occurrence | no | Occurrence | null | ||
operation | yes | string | ||
parent | yes | string | ||
plugin | no | string | "" | |
started_at | yes | string | ||
status | yes | pending | running | succeeded | failed | canceled | ||
summary | no | string | "" | |
target | no | string | "" | |
type | no | step | "step" | |
usage | no | TokenUsage | null |
Schema: Struct_Value_
One immutable authored Toolang struct value.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
type | yes | string | ||
value | yes | object<string, Value> |
Schema: TextInputPart
One text input part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
text | yes | string | ||
type | yes | text |
Schema: TextPart-Input
One canonical text part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
provider | no | string | null | ||
provider_metadata | no | object | ||
signature | no | string | null | ||
text | yes | string | ||
type | no | text | "text" |
Schema: TextPart-Output
One canonical text part.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
provider | no | string | null | ||
provider_metadata | no | object | ||
signature | no | string | null | ||
text | yes | string | ||
type | no | text | "text" |
Schema: ThreadControlRefData
One caller-facing thread-control reference.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
index | yes | integer | ||
thread | yes | string |
Schema: ThreadCreateRequest
Request one empty thread.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
request_id | no | string | null | string: length >= 1 |
Schema: ThreadDetail
One complete thread detail schema.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
active_run | yes | ThreadRunInfo | null | ||
created_at | yes | string | ||
created_by | yes | ThreadControlRefData | ||
head | yes | ThreadControlRefData | ||
id | yes | string | ||
latest_run | yes | ThreadRunInfo | null | ||
run_count | yes | integer | ||
runs | no | array<RunDetail> | ||
status | yes | string | ||
title | yes | string | ||
updated_at | yes | string |
Schema: ThreadForkRequest
Request a thread fork from one anchor run.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
request_id | no | string | null | ||
run_id | no | string | null | string: length >= 1 |
Schema: ThreadInfo
One thread summary, with latest_run identifying its latest visible root.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
active_run | yes | ThreadRunInfo | null | ||
created_at | yes | string | ||
created_by | yes | ThreadControlRefData | ||
head | yes | ThreadControlRefData | ||
id | yes | string | ||
latest_run | yes | ThreadRunInfo | null | ||
run_count | yes | integer | ||
status | yes | string | ||
title | yes | string | ||
updated_at | yes | string |
Schema: ThreadResult
One HTTP thread mutation response.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
thread | yes | ThreadInfo |
Schema: ThreadRewindRequest
Request a thread rewind from one anchor run.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
client_id | no | string | null | string: length >= 1 | |
request_id | no | string | null | ||
run_id | no | string | null | string: length >= 1 |
Schema: ThreadRunInfo
One compact run summary embedded in a thread summary.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
created_at | yes | string | ||
finished_at | yes | string | null | ||
id | yes | string | ||
started_at | yes | string | ||
status | yes | pending | running | succeeded | failed | canceled | ||
updated_at | yes | string |
Schema: TokenUsage
Inclusive token totals and optional client-relevant components.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cache_read_tokens | no | integer | null | ||
input_tokens | yes | integer | ||
output_tokens | yes | integer | ||
reasoning_tokens | no | integer | null |
Schema: ToolCall
One tool invocation initiated by a model or the runtime.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_id | yes | string | ||
input | yes | object | ||
name | yes | string | ||
tool_call_id | yes | string |
Schema: ToolCallPart-Input
One canonical tool-call part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_id | no | string | null | ||
input | no | object | ||
provider | no | string | null | ||
provider_metadata | no | object | ||
signature | no | string | null | ||
tool_call_id | yes | string | ||
tool_family | yes | string | ||
tool_name | yes | string | ||
type | no | tool_call | "tool_call" |
Schema: ToolCallPart-Output
One canonical tool-call part.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_id | no | string | null | ||
input | no | object | ||
provider | no | string | null | ||
provider_metadata | no | object | ||
signature | no | string | null | ||
tool_call_id | yes | string | ||
tool_family | yes | string | ||
tool_name | yes | string | ||
type | no | tool_call | "tool_call" |
Schema: ToolDefinition
One model-facing tool definition.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
description | yes | string | ||
name | yes | string | ||
parameters | no | object |
Schema: ToolResultPart-Input
One canonical tool-result part.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_id | no | string | null | ||
error | no | string | null | ||
output | no | object | ||
tool_call_id | yes | string | ||
tool_family | yes | string | ||
tool_name | yes | string | ||
type | no | tool_result | "tool_result" |
Schema: ToolResultPart-Output
One canonical tool-result part.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call_id | no | string | null | ||
error | no | string | null | ||
output | no | object | ||
tool_call_id | yes | string | ||
tool_family | yes | string | ||
tool_name | yes | string | ||
type | no | tool_result | "tool_result" |
Schema: ToolStepReport
Human-readable terminal summary learned when a tool Step ends.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
invoked | no | boolean | false | |
summary | yes | string |
Schema: ToolStepSpec
Resolved plugin, invocation provenance, and call known at Step begin.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
call | yes | ToolCall | ||
plugin | yes | string | ||
summary | no | string | "" | |
trigger | no | model | runtime | "model" |
Schema: WindowRow
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
cached | yes | integer | null | ||
end | yes | string | null | ||
in | yes | integer | null | ||
model_calls | yes | integer | ||
out | yes | integer | null | ||
root_runs | yes | integer | null | ||
spend | yes | number | null | ||
spend_approximate | yes | boolean | ||
start | yes | string | null | ||
tool_calls | yes | integer | ||
window | yes | all | 1y | 1mo | 1w | 1d | 4h | 1h | 30m |
Schema: WorkdirResolveRequest
Resolve one session or run workdir without creating a Run.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
thread_id | no | string | null | ||
workdir | no | string | null | ||
workdir_base | no | string | null |
Schema: WorkspaceInfo
One State grant and its availability in the inspecting runtime.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
available | yes | boolean | ||
name | yes | string | ||
path | yes | string |
Schema: WorkspaceInspection
Workspace inspection bound to one published State revision.
Additional fields are rejected.
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
items | yes | array<WorkspaceInfo> | ||
revision | yes | string | ||
workdir | yes | string | null |
Schema: WorkspaceRecallTarget
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
kind | no | workspace | "workspace" | |
ref | yes | string |
Schema: CreateControlPayload
Create one empty thread.
Type: object
Schema: ThreadKind
Context kinds encoded by canonical Thread ID prefixes.
Values: chat, chore, talk, work, exec
Schema: Value
Type: string | integer | number | boolean | TextPart-Output | ReasoningPart-Output | ImagePart-Output | AudioPart-Output | DocumentPart-Output | ToolCallPart-Output | ToolResultPart-Output | Array_Value_ | Struct_Value_ | array<Value> | object<string, Value> | null
Schema: HTTPValidationError
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
detail | no | array<ValidationError> |
Schema: ValidationError
| Field | Required | Type | Default | Description |
|---|---|---|---|---|
ctx | no | object | ||
input | no | any | ||
loc | yes | array<string | integer> | ||
msg | yes | string | ||
type | yes | string |